function w = FD2Analysis(x, n)

x = reshape(x, n, n);

% vertical
w1 = x(:, 2:end) - x(:, 1:(end-1));
w1 = w1(:, 2:end) - w1(:, 1:(end-1));

% horizontal
w2 = x(2:end, :)-x(1:(end-1), :);
w2 = w2(2:end, :) - w2(1:(end-1), :);

% diagonal
w3 = x(2:end, 2:end) - x(1:(end-1), 1:(end-1));
w3 = w3(2:end, 2:end) - w3(1:(end-1), 1:(end-1));

% anti-diagonal
w4 = x(2:end, 1:(end-1)) - x(1:(end-1), 2:end);
w4 = w4(2:end, 1:(end-1)) - w4(1:(end-1), 2:end);

w = [ w1(:); w2(:); w3(:); w4(:) ];

