function x = FDfSynthesis(w, n)

e1 = n*(n-1);
t1 = reshape(w(1:e1), n, n-1);
e2 = e1 + n*(n-1);
t2 = reshape(w((e1+1):e2), n-1, n);
e3 = e2 + (n-1)*(n-1);
t3 = reshape(w((e2+1):e3), n-1, n-1);
t4 = reshape(w((e3+1):end), n-1, n-1);

x = zeros(n, n);
x(:, 2:end) = t1;
x(:, 1:(end-1)) = x(:, 1:(end-1)) - t1;
x(2:end, :) = x(2:end, :) + t2;
x(1:(end-1), :) = x(1:(end-1), :) - t2;
x(2:end, 2:end) = x(2:end, 2:end) + t3;
x(1:(end-1), 1:(end-1)) = x(1:(end-1), 1:(end-1)) - t3;
x(2:end, 1:(end-1)) = x(2:end, 1:(end-1)) + t4;
x(1:(end-1), 2:end) = x(1:(end-1), 2:end) - t4;

x = x(:);

