function x = WTSynthesis(w, n)

t = reshape(w(1:(2*n*(n-1))), 2*n, n-1);
x = zeros(n, n);
x(:, 2:end) = t(1:n, :);
x(:, 1:(end-1)) = x(:, 1:(end-1)) - t(1:n, :);
x(2:end, :) = x(2:end, :) + t((n+1):end, :).';
x(1:(end-1), :) = x(1:(end-1), :) - t((n+1):end, :).';

t = reshape(w((2*n*(n-1)+1):end)/2, 2*(n-1), n-3);
x(1:(end-1), 3:(end-1)) = x(1:(end-1), 3:(end-1)) + t(1:(n-1), :);
x(1:(end-1), 4:end) = x(1:(end-1), 4:end) + t(1:(n-1), :);
x(2:end, 3:(end-1)) = x(2:end, 3:(end-1)) + t(1:(n-1), :);
x(2:end, 4:end) = x(2:end, 4:end) + t(1:(n-1), :);
x(1:(end-1), 1:(end-3)) = x(1:(end-1), 1:(end-3)) - t(1:(n-1), :);
x(1:(end-1), 2:(end-2)) = x(1:(end-1), 2:(end-2)) - t(1:(n-1), :);
x(2:end, 1:(end-3)) = x(2:end, 1:(end-3)) - t(1:(n-1), :);
x(2:end, 2:(end-2)) = x(2:end, 2:(end-2)) - t(1:(n-1), :);

x(3:(end-1), 1:(end-1)) = x(3:(end-1), 1:(end-1)) + t(n:end, :).';
x(4:end, 1:(end-1)) = x(4:end, 1:(end-1)) + t(n:end, :).';
x(3:(end-1), 2:end) = x(3:(end-1), 2:end) + t(n:end, :).';
x(4:end, 2:end) = x(4:end, 2:end) + t(n:end, :).';
x(1:(end-3), 1:(end-1)) = x(1:(end-3), 1:(end-1)) - t(n:end, :).';
x(2:(end-2), 1:(end-1)) = x(2:(end-2), 1:(end-1)) - t(n:end, :).';
x(1:(end-3), 2:end) = x(1:(end-3), 2:end) - t(n:end, :).';
x(2:(end-2), 2:end) = x(2:(end-2), 2:end) - t(n:end, :).';

x = x(:);
